package io.nisum.designpattern.employee.repo;

import io.nisum.designpattern.employee.entity.Employee;
import org.springframework.data.repository.reactive.ReactiveCrudRepository;
import org.springframework.stereotype.Repository;
import reactor.core.publisher.Flux;
import reactor.core.publisher.Mono;

@Repository
public interface EmployeeRepository extends ReactiveCrudRepository<Employee, Long> {
    Flux<Employee> findByDepartmentId( long departmentId );
    Flux<Employee> findByOrganizationId( long organizationId );
    Mono<Employee> findByName( String name );
}
