package io.nisum.designpattern.organization.controller;

import io.nisum.designpattern.organization.dto.OrganizationDto;
import io.nisum.designpattern.organization.service.OrganizationService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import reactor.core.publisher.Flux;
import reactor.core.publisher.Mono;

@Slf4j
@RestController
@RequestMapping("/organizations")
public class OrganizationController {

    @Autowired
    OrganizationService organizationService;

    @PostMapping
    public Mono<OrganizationDto> add(@RequestBody Mono<OrganizationDto> organization) {
        log.info("Organization add: {}", organization);
        return organizationService.save(organization);
    }

    @GetMapping
    public Flux<OrganizationDto> findAll() {
        log.info("Organization find");
        return organizationService.findAll();
    }

    @GetMapping("/{id}")
    public Mono<OrganizationDto> findById(@PathVariable("id") long id) {
        log.info("Organization find: id={}", id);
        return organizationService.findById(id);
    }

}
